#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		opt		/opt
%define		jdkver		%(echo %{version})
%define		jdkdir		%{opt}/%{name}-%{jdkver}
#-----------------------------------------------------------------------------
Name		:	jdk8u
Version		:	jdk8u392
Release		:	17.0.10.rel%{?dist}
Summary		:	OpenJDK is an open-source implementation of Oracle's Java Standard Edition platform.
Group		:	Development/Languages

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	ASL 1.1 and ASL 2.0 and GPL+ and GPLv2 and GPLv2 with exceptions and LGPL+ and LGPLv2 and MPLv1.0 and MPLv1.1 and Public Domain and W3C
URL		:	https://github.com/openjdk/jdk8u/

Source0		:	%{name}-%{version}-ga.tar.gz
Source2		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	alsa-lib
BuildRequires	:	cpio
BuildRequires	:	cups-devel
BuildRequires	:	giflib
BuildRequires	:	lcms2
BuildRequires	:	libjpeg-turbo-devel
BuildRequires	:	libpng-devel
BuildRequires	:	make-ca
BuildRequires	:	unzip
BuildRequires	:	which
BuildRequires	:	xorg-libXrandr
BuildRequires	:	xorg-libXt
BuildRequires	:	xorg-libXtst
BuildRequires	:	zip
BuildRequires	:	zlib

BuildRequires	:	jdk8u-bootstrap

Requires(post)	:	%{_bindir}/gtk-update-icon-cache
Requires(post)	:	%{_bindir}/update-desktop-database
Requires	:	make-ca

Obsoletes	:	jdk8u-bootstrap	<= 1.8.0.141
#-----------------------------------------------------------------------------
%description
OpenJDK is useful for developing Java programs, and provides a complete
runtime environment to run Java programs.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc THIRD_PARTY_README ASSEMBLY_EXCEPTION
%license LICENSE
%{_bindir}/javac8u
%{opt}/%{name}
%{jdkdir}/bin/
%{jdkdir}/bin/keytool
%{jdkdir}/bin/rm*
%{jdkdir}/bin/serialver
%{jdkdir}/demo/*
%{jdkdir}/include/*
%{jdkdir}/jre/*
%{jdkdir}/lib/*
%{jdkdir}/man/*
%{jdkdir}/sample/*
%{jdkdir}/src.zip
%{jdkdir}/release

%{_sysconfdir}/profile.d/open%{name}.sh
%{_datadir}/applications/%{name}-*.desktop

%postun
if [ $1 -eq 0 ] ; then
  %{_bindir}/update-desktop-database > /dev/null 2>&1
  %{_bindir}/gtk-update-icon-cache -f -t %{_datadir}/icons/hicolor > /dev/null 2>&1
  fi

%post
%{_bindir}/gtk-update-icon-cache -t %{_datadir}/icons/hicolor > /dev/null 2>&1
%{_bindir}/update-desktop-database > /dev/null 2>&1

#=============================================================================
%prep
%setup -q -n %{name}-%{version}-ga
tar -xf %{SOURCE2}

#-----------------------------------------------------------------------------
#building application
%build

#must be set ENV variable
. /etc/profile
. /etc/profile.d/openjdk.sh

unset JAVA_HOME
bash configure							\
        --prefix=%{_prefix}					\
	--includedir=%{_includedir}				\
        --sysconfdir=%{_sysconfdir}				\
	--bindir=%{_bindir}					\
	--sbindir=%{_sbindir}					\
	--libdir=%{_libdir}					\
	--mandir=%{_mandir}					\
	--enable-unlimited-crypto				\
	--with-stdc++lib=dynamic				\
	--with-giflib=system					\
	--with-zlib=system					\
	--with-cacerts-file=/etc/pki/tls/java/cacerts		\
	--with-boot-jdk=/opt/jdk8u				\

unset MAKEFLAGS
#CFLAGS set, to allow compilatione.
export CFLAGS="$CFLAGS -Wno-register -Wno-nonnull"
%define _smp_mflags JOBS=%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}							\
	DEBUG_BINARIES=true					\
	SCTP_WERROR=						\
	%{_smp_mflags}						\
	images

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}
%{__mkdir_p}							\
	%{buildroot}%{_bindir}/					\
	%{buildroot}%{_datadir}/applications/			\
	%{buildroot}%{_sysconfdir}/profile.d/			\
	%{buildroot}%{opt}/					\

#installing jdk components
%{__cp} -a							\
	build/*/images/j2sdk-image				\
	%{buildroot}%{opt}/%{name}

%{__mv}								\
	%{buildroot}%{opt}/%{name}				\
	%{buildroot}%{jdkdir}

%{__ln_s}							\
	./%{name}-%{jdkver}					\
	%{buildroot}%{opt}/%{name}

#set javac in /usr/bin
%{__ln_s}							\
	../..%{opt}/%{name}/bin/javac				\
	%{buildroot}%{_bindir}/javac8u

#set all librairy in executable mode
find 								\
	%{buildroot}%{jdkdir}/lib				\
	-name \*.so						\
	-exec chmod 755 {} \;


#installing desktop components
cat > %{buildroot}%{_datadir}/applications/%{name}-java.desktop << "EOF"
[Desktop Entry]
Name=OpenJDK Java %{name}-%{jdkver} Runtime
Comment=OpenJDK Java %{name}-%{jdkver} Runtime
Exec=%{opt}/%{name}/bin/java -jar
Terminal=false
Type=Application
Icon=java
MimeType=application/x-java-archive;application/java-archive;application/x-jar;
EOF

cat > %{buildroot}%{_datadir}/applications/%{name}-jconsole.desktop << "EOF"
[Desktop Entry]
Name=OpenJDK Java %{name}-%{jdkver} Console
Comment=OpenJDK Java %{name}-%{jdkver} Console
Keywords=java;console;monitoring
Exec=%{opt}/%{name}/bin/jconsole
Terminal=false
Type=Application
Icon=java
Categories=Application;System;
EOF

#installing profile component
sed -i								\
    -e  "s:@@JHOME@@:%{opt}/%{name}:"				\
	%{name}-ok_addon/open%{name}.sh
%{__cp} -a							\
	%{name}-ok_addon/open%{name}.sh				\
	%{buildroot}%{_sysconfdir}/profile.d

%{__rm} -f							\
	%{buildroot}/%{jdkdir}/ASSEMBLY_EXCEPTION		\
	%{buildroot}/%{jdkdir}/LICENSE				\
	%{buildroot}/%{jdkdir}/THIRD_PARTY_README		\

	
#to check certificat installation
# cd /opt/%{name}
# bin/keytool -list -cacerts
# the default keystore password "changeit"

#-----------------------------------------------------------------------------
%changelog
